# Améliorations

---

## But

Améliorer notre programme pour qu'il fasse vraiment déplacer **Scratch** jusqu'au bord de l'écran.

## Analyse de la situation

Pour l'instant, **Scratch** ne se déplace qu'un peu lorsqu'on clique sur le drapeau.

Pour arranger ca, plusieurs solutions sont possibles :

- changer la valeur du déplacement dans l'ordre *"avancer"* ;
- recopier plusieurs fois l'ordre *"avancer"*.

Changer la valeur est effectivement possible, on peut changer le *10* en un nombre plus grand. Mais quel nombre ? En plus, le nombre va dépendre de la place de départ de **Scratch**.

!!! note
    La place de départ de **Scratch** est facilement changeable, il suffit simplement de cliquer et déplacer **Scratch** dans la scène.

C'est pareil pour la répétition, on ne sait pas combien de fois il faut répéter l'ordre.

Il nous faut donc une répétition intelligente, qui ne répète que le nombre nécessaire de fois.

## Les boucles

Pour avoir une répétition intelligente, il faut déjà avoir une répétition !

Les répétitions font parties des ordres jaunes, *"Controle"* :

![Ordres Jaune](images/prog1bis/ordres_jaune.png)

Il y a plusieurs ordres de répétitions possibles : les répétitions avec un nombre de fois fixées, les répétitions "à l'infini"...

Ce qui nous intéresse, nous, c'est de répéter jusqu'à ce que **Scratch** touche le bord de l'écran. Il nous faut donc la répétition *"répéter jusqu'à"* : 

![Repeter Jusqua](images/prog1bis/repeter_jusqua.png)

Pour l'utiliser, il faut faire glisser cet ordre juste en dessous de l'ordre *"quand le drapeau vert est cliqué"*. Le bloc bleu va alors se mettre à l'intérieur du bloc jaune, car c'est le bloc bleu qui va être répété :

![Repeter](images/prog1bis/repeter.png)

!!! attention
    Si le bloc bleu n'est pas **DANS** le block jaune, alors le programme ne va pas fonctionner.
    Si c'est le cas, déplace le bloc bleu pour qu'il soit dans le bloc jaune, comme indiqué au dessus.

## Les conditions

Maintenant, notre programme répète le déplacement jusqu'à... jusqu'à quand justement ? Pour l'instant, nous n'avons pas dit jusqu'à quand.

Il nous faut un moyen de dire : "jusqu'à ce que **Scratch** touche le bord de l'écran".

Pour cela, on peut remarquer que lorsque **Scratch** se déplace vers la droite, il y a un chiffre qui change, indiqué juste en dessous - c'est le chiffre *x* :

![X](images/prog1bis/x.png)

Si on déplace **Scratch** vers le bord de l'écran, on voit que *x* arrive vers la valeur *180*. Ce qu'il nous faut donc, c'est dire : "répéter jusqu'à ce que x ait au moins la valeur 180".

Pour cela, il nous faut la valeur de *x*, et il nous faut faire un *test* sur cette valeur, pour voir si elle vaut bien 180 ou plus.

Les tests se font avec les ordres verts, *"Opérateurs"* :

![Ordres Vert](images/prog1bis/ordres_vert.png)

Ici, le test à faire, c'est voir si *x* a au moins une certaine valeur, c'est à dire si *x* est plus grand qu'une certaine valeur. Il nous faut donc le test *">"* : 

![Superieur](images/prog1bis/superieur.png)

Pour utiliser cet ordre, il faut le faire glisser dans le trou du bloc jaune qui se trouve juste après le mot "jusqu'à" :

![Emplacement 1](images/prog1bis/emplacement_1.png)

Ce qui donne : 

![Repeter 2](images/prog1bis/repeter_2.png)

!!! note
    Une petite lumière blanche apparait autour du trou du bloc jaune lorsqu'on approche le bloc vert. C'est le signe que le bloc vert va bien aller à la bonne place dans le bloc jaune.

Il nous reste maintenant à mettre *x* à gauche, et *180* à droite.

## Les variables

Une variable, c'est une sorte de tiroir dans lequel on garde une valeur. Ici, *x* est une variable, c'est le tiroir dans lequel on garde la position de **Scratch**.

Cette variable se trouve dans les ordres bleus, *"Mouvements"*, tout en bas, sous le nom *"abscisse x"* :

![Abscisse](images/prog1bis/abscisse.png)

Il faut la faire glisser dans le trou gauche de l'ordre vert : 

![Trou Gauche](images/prog1bis/trou_gauche.png)

ce qui donne : 

![Repeter 3](images/prog1bis/repeter_3.png)

!!! note
    Comme pour le bloc jaune, une petite lumière blanche apparait autour du trou du bloc vert lorsqu'on approche le bloc bleu. C'est le signe que le bloc bleu va bien aller à la bonne place dans le bloc vert.

Il ne nous reste plus qu'à mettre la valeur voulue dans le trou droit du bloc vert. Pour cela, il suffit de cliquer dedans et de taper "180" : 

![Repeter 4](images/prog1bis/repeter_4.png)

## Tester

Pour tester, il suffit de remettre **Scratch** au milieu de l'écran, et d'appuyer sur le drapeau vert. **Scratch** va alors bien se déplacer jusqu'au bord de l'écran.

Et on peut répéter le test autant qu'on veut, en placant **Scratch** à n'importe quel endroit de l'écran, que ce soit tout à gauche ou vers la droite, lorsqu'on appuie sur le drapeau vert, il va bien jusqu'au bord de l'écran, et il s'arrête au bord.

!!! success "Bravo !"
    Voilà, vous avez fait un programme qui fait bien ce que vous aviez demandé !

Maintenant que vous savez faire tout ca, à vous de jouer !

Allez donc sur la [page suivante](defis.md), vous trouverez quelques défis à relever.

!!! summary "Résumé"
    Vous avez vu ici :
    
    - les répétitions (ordre jaune)
    - les tests (ordre vert)
    - les variables, et en particulier la variable *x* (ordre bleu)
